package cviceni04;

import java.util.*;

class Osoba implements Comparable<Osoba> {
  int vyska;
  double vaha;
  String popis;

  Osoba(int vyska, double vaha, String popis) {
    this.vyska = vyska;
    this.vaha = vaha;
    this.popis = popis;
  }

  public int compareTo(Osoba os) {
    return this.vyska - os.vyska;
  }

  public String toString() {
    return "vy = " + vyska + ", va = " + vaha + ", " + popis;
  }
}

class KomparatorOsobyPodleVysky implements Comparator<Osoba> {
  public int compare(Osoba os1, Osoba os2) {
    return os1.vyska - os2.vyska;
  }
}

class KomparatorOsobyPodleVahy implements Comparator<Osoba> {
  public int compare(Osoba os1, Osoba os2) {
    return (int) (os1.vaha - os2.vaha);
  }
}

class KomparatorOsobyPodleVahyObracene implements Comparator<Osoba> {
  public int compare(Osoba os1, Osoba os2) {
    return (int) (os2.vaha - os1.vaha);
  }
}

class KomparatorOsobyPodlePopisu implements Comparator<Osoba> {
  public int compare(Osoba os1, Osoba os2) {
    String s1 = os1.popis;
    String s2 = os2.popis;
    return s1.compareTo(s2);
  }
}

public class ArraysAbsolutniRazeni_3 {
  static Osoba[] poleOsob;

  static void vypisOsoby() {
    for (int i = 0;  i < poleOsob.length;  i++)
      System.out.println("[" + i + "] " + poleOsob[i]);
  }

  public static void main(String[] args) {
    poleOsob = new Osoba[5];
    poleOsob[0] = new Osoba(186, 82.5, "muz");
    poleOsob[1] = new Osoba(172, 63.0, "Zena");
    poleOsob[2] = new Osoba(105, 26.1, "dite");
    poleOsob[3] = new Osoba(116, 80.5, "prcek");
    poleOsob[4] = new Osoba(183, 86.5, "sportovec");
    
    System.out.println("\nPrirozene razeni");
    Arrays.sort(poleOsob);
    vypisOsoby();

    System.out.println("\nAbsolutni razeni podle vahy");
    Arrays.sort(poleOsob, new KomparatorOsobyPodleVahy());
    vypisOsoby();

    System.out.println("\nAbsolutni razeni podle popisu");
    Arrays.sort(poleOsob, new KomparatorOsobyPodlePopisu());
    vypisOsoby();

    System.out.println("\nPrirozene razeni podle vysky sestupne");
    Arrays.sort(poleOsob, Collections.reverseOrder());
    vypisOsoby();

    System.out.println("\nAbsolutni razeni podle vahy sestupne - 1");
    Arrays.sort(poleOsob, Collections.reverseOrder(
                          new KomparatorOsobyPodleVahy()));
    vypisOsoby();

    System.out.println("\nAbsolutni razeni podle vahy sestupne - 2");
    Arrays.sort(poleOsob, new KomparatorOsobyPodleVahyObracene());
    vypisOsoby();

//    System.out.println("\n-----------");
//    System.out.println(Arrays.asList(poleOsob)); //--- KUBA: Jak dosahneme odradkovani?
//    System.out.println("-----------");
//    vypisOsoby();

    //-----------------------------------------------------
    //--- Kopirovani pole
    Osoba[] novePole = Arrays.copyOfRange(poleOsob, 0, 2);
    System.out.println("\nPole osob delky " + novePole.length);
    for(Osoba o : novePole){
        System.out.println(o);
    }

    System.out.println("\nPole osob delky " + poleOsob.length);
    for(Osoba o : poleOsob){
        System.out.println(o);
    }

    poleOsob[0].vyska = 190;
    System.out.println("\nPuvodni: " + poleOsob[0].vyska + ", " + poleOsob[0].vaha);
    System.out.println("Nove: " + novePole[0].vyska + ", " + novePole[0].vaha);

  }
}
